stages:
  - unittest
  - functional-test
  - deploy
  - document

unittest:
  image: python:latest
  stage: unittest
  only:
    - master
  script:
    - pip install --trusted-host pypi.python.org -r requirements.txt && rm -r requirements.txt
    - cd src
    - python -m unittest discover `find . -name tests`

functional-test:
  image: docker:latest
  stage: functional-test
  services:
    - docker:dind
  only:
    - master
  script:
    - apk add --no-cache py-pip postgresql-libs postgresql-dev python-dev libffi-dev openssl-dev gcc libc-dev make
    - pip install docker-compose
    - docker-compose build
    - docker-compose up -d
    - docker exec -i db apt-get update
    - docker exec -i db apt-get install netcat --assume-yes
    - docker exec -i db /bin/bash -c "while ! nc -zv 127.0.0.1 5432; do sleep 1; done"
    - docker exec -i nlp-service apt-get update
    - docker exec -i nlp-service apt-get install netcat --assume-yes
    - docker exec -i nlp-service /bin/bash -c "while ! nc -zv 127.0.0.1 5000; do sleep 1; done"
    - docker exec -i nlp-service tavern-ci tests

heroku-deploy:
  image: docker:latest
  stage: deploy
  services:
    - docker:dind
  only:
    - master
  script:
    - docker build -t registry.heroku.com/msfloss-nlp/web .
    - docker login -u _ -p $HEROKU_API_KEY registry.heroku.com
    - docker push registry.heroku.com/msfloss-nlp/web
    - docker run --rm -e HEROKU_API_KEY=$HEROKU_API_KEY -e DB_URI=$DB_URI wingrunr21/alpine-heroku-cli container:release web --app msfloss-nlp

pages:
  image: node:latest
  stage: document
  only:
   - master
  script:
    - mkdir public
    - mkdir public/swaggerui
    - curl http://msfloss-nlp.herokuapp.com/ | sed -e "s/\/swaggerui\//\.\/swaggerui\//g" | sed "s/http\:\/\/msfloss-nlp.herokuapp.com\/swagger\.json/https\:\/\/flusp.gitlab.io\/msfloss\/nlp-service\/swagger\.json/g" > public/index.html
    - curl http://msfloss-nlp.herokuapp.com/swaggerui/droid-sans.css > public/swaggerui/droid-sans.css
    - curl http://msfloss-nlp.herokuapp.com/swaggerui/swagger-ui.css > public/swaggerui/swagger-ui.css
    - curl http://msfloss-nlp.herokuapp.com/swaggerui/swagger-ui-bundle.js > public/swaggerui/swagger-ui-bundle.js
    - curl http://msfloss-nlp.herokuapp.com/swaggerui/swagger-ui-standalone-preset.js > public/swaggerui/swagger-ui-standalone-preset.js
    - curl http://msfloss-nlp.herokuapp.com/swagger.json > public/swagger.json
  artifacts:
    paths:
    - public
